#include "enginepart.hpp"

EnginePart::~EnginePart()
{

}

int EnginePart::run()
{
    while(true)
    {
        timer->start();

        SDL_Event event;

        int message;
        while( SDL_PollEvent( &event ) )
        {
          message=input(event);
          if (message!=0)
            return message;
        }

      message=logic();
        if (message!=0)
          return message;

        draw();
        graphicsengine->flip();

        if( timer->get_ticks() < 1000 / FRAMES_PER_SECOND )
        {
            SDL_Delay( ( 1000 / FRAMES_PER_SECOND ) - timer->get_ticks() );
        }
    }

    return 0;
}

EnginePart::EnginePart(const SubengineInterface* subengines)
{
  timer=subengines->timer;
  graphicsengine=subengines->graphicsengine;
  soundengine=subengines->soundengine;
}
