#ifndef MODEL_HPP
#define MODEL_HPP

#include <vector>
#include <string>

#include "SDL/SDL.h"
#include "SDL/SDL_opengl.h"

using namespace std;

typedef GLfloat Vertex3[3];
typedef GLfloat Vertex2[3];
typedef int facevertex[2];

class Model {
public:
	vector<GLfloat> vertices_flat;
	vector<vector<int> > faces;//contains list of points (vertex1,textcoord1,vertex2,textcoord2,vertex2,textcoord3)
	vector<GLfloat> texturecoords_flat;
	GLuint texture;
	GLuint dlist;
	bool load(const char* filename, const char* texture);
private:
	void render();
	void loadTexture(const char* texture_path);
};

#endif /* MODEL_HPP */

