#include "engineinstance.hpp"

#include "intropart.hpp"
#include "titlepart.hpp"
#include "mainpart.hpp"
#include "cutscene.hpp"
#include "ending1.hpp"
#include "ending2.hpp"

GameEngine::GameEngine()
{
  global_variables = new Global_Variables();

  soundengine->loadsound("audio/blip.wav");
  soundengine->loadsound("audio/pickup.wav");
  soundengine->loadsound("audio/steps.wav");
  soundengine->streamtrack("audio/0.xm");

  graphicsengine->loadmodel("models/bedroom.obj","textures/bedroom.bmp");
	graphicsengine->loadmodel("models/man1.obj","textures/man1.bmp");
	graphicsengine->loadmodel("models/man2.obj","textures/man2.bmp");
	graphicsengine->loadmodel("models/man3.obj","textures/man3.bmp");
	graphicsengine->loadmodel("models/man3b.obj","textures/man3pants.bmp");
	graphicsengine->loadmodel("models/dildo.obj","textures/dildo1.bmp");
	graphicsengine->loadmodel("models/dildo.obj","textures/dildo2.bmp");
	graphicsengine->loadmodel("models/dildo.obj","textures/dildo3.bmp");

  section.push_back(new IntroPart ( this , global_variables ) );
  section.push_back(new TitlePart ( this , global_variables ) );
  section.push_back(new CutScene  ( this , global_variables ) );
  section.push_back(new MainPart  ( this , global_variables ) );
  section.push_back(new Ending1   ( this , global_variables ) );
  section.push_back(new Ending2   ( this , global_variables ) );

}

GameEngine::~GameEngine()
{
}


int GameEngine::control(int oldpart, int message)
{
  if (message<0)
    return -1;

  switch (oldpart)
  {
    case 0://intro
      return 1;
      break;
    case 1://title
      return 2;
      break;
    case 2://cutscene 1
      return 3;
      break;
    case 3://main game
    std::cout<<"MESSAGE"<<message<<","<<oldpart<<"\n";
      switch (message)
      {
          case 1:
            return 4;
          break;
          case 2:
            return 5;
          break;
          case 3:
            return 1;
          break;
          default:
            return -1;
          break;
      }
      break;
    case 4://good ending
      return -1;
      break;
    case 5://bad ending
      return 1;
      break;
  }
 return -1;
}
