#ifndef ENTITIES_HPP
#define ENTITIES_HPP

#include "SDL/SDL.h"
#include "SDL/SDL_opengl.h"

#include "Engine/font.hpp"

const int ROOM_MODEL=0;

const int wallcount=15;
const GLfloat roomcollisions[wallcount][2][2] =
{
//basic room rectangle
{{2,1},{-2,1}},
{{-2,1},{-2,-0.2}},
{{-2,-0.8},{-2,-2.6}},
{{-2,-2.6},{2,-2.6}},
{{2,-2.6},{2,1}},
//room to the right
{{-2,-0.2},{-2.8,-0.2}},
{{-2.8,-0.2},{-2.8,-0.8}},
{{-2.8,-0.8},{-2,-0.8}},
//bed
{{2,-1.5},{0.45,-1.5}},
{{0.45,-1.5},{0.45,-0.5}},
{{2,-0.5},{0.45,-0.5}},
//left screen
{{1.5,0.1},{1.5,0.5}},
{{1.5,0.5},{0.75,0.5}},
//middle screen
{{0.25,0.5},{-0.5,0.5}},
//right screen
{{-1,0.5},{-1.5,0.5}}
};

const float playerwidth=0.20;

class Dildo {
public:
	GLfloat x;
	GLfloat y;
	GLfloat z;
	int state;//0 nothing, 1 selected, 2 inserted, 3 discarded
	GLuint dlist;
};

struct Position {
	GLfloat x;
	GLfloat y;
};

class Entity {
public:
	Position pos;
	GLfloat Direction;
	int curframe;
	GLuint roomoutlines;
	Entity() { pos.x=0; pos.y=0;};
	virtual void input(const SDL_Event& event) = 0;
	virtual void move(float x1,float y1,float x2,float y2) = 0;
	virtual void draw() {};
};


class Lover : public Entity{
public:
	bool moving[4];
  GLuint dlist;
	GLfloat angle;
	bool visible();
	void calcrotate();
  void input(const SDL_Event& event);
	void move(float x1,float y1,float x2,float y2);
	void draw();
	Lover();
};

class Boss : public Entity{
public:
	bool moving[4];
  GLuint dlist1;
  GLuint dlist2;
	bool onbed;
	GLfloat angle;
	int speechlength;
	int tosay;
	FontRenderer* fontrenderer; //need to assign this manually
	bool language; //ditto
	bool cansee;
	void saysomething(int text_tosay);
	void input(const SDL_Event& event){};
	void move(float x1,float y1,float x2,float y2){};
	void draw();
	Boss();
};

class Wife : public Entity{
public:
	bool moving[4];
  GLuint dlist;
	GLfloat angle;
	Dildo* dildo;//an array; need to assign manually
	Boss* boss;
	GLfloat* hidecounter;
	int carrying;
	void calcrotate();
	void input(const SDL_Event& event);
	void move(float x1,float y1,float x2,float y2);
	void draw();
	Wife();
};

#endif /* ENTITIES_HPP */
