#include "titlepart.hpp"
#include "mainpart.hpp"
#include "gamestrings.hpp"

void TitlePart::reset()
{
    state->intstate=0;
}

TitlePart::TitlePart(const SubengineInterface* subengines, Global_Variables* p_global_variables):
EnginePart(subengines),
state(new Title_State),
global_variables(p_global_variables)
{
      soundengine->streamtrack("audio/0.xm");
}

TitlePart::~TitlePart()
{
  delete state;
}

int TitlePart::input(const SDL_Event& event)
{
  if( event.type == SDL_KEYDOWN )
  {
    switch( event.key.keysym.sym )
    {
      case SDLK_ESCAPE:
        return -1;
        break;
      case SDLK_SPACE:
      case SDLK_RETURN:
        switch (state->intstate)
        {
          case 0:
            return 1+global_variables->language;//return 1 if english selected, 2 if spanish selected
            soundengine->streamtrack("audio/0.xm");
            break;
          case 1:
            global_variables->language=!global_variables->language;
            soundengine->play(0);
            break;
          case 2:
            return -1;
            break;
        }
        break;
      case SDLK_UP:
        state->intstate=(state->intstate+2)%3;
        soundengine->play(0);
        break;
      case SDLK_DOWN:
        state->intstate=(state->intstate+1)%3;
        soundengine->play(0);
      break;
    default:
      break;
    }
  }

  return 0;
}

int TitlePart::logic()
{
  return 0;
}

void TitlePart::draw()
{
  glLoadIdentity();


  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  glColor3f(1,1,1);

  graphicsengine->fontrenderer->glPrint(200, 300, titledialog[1][global_variables->language].c_str(), 0);

  if (state->intstate==0)
    glColor3f(1,1,1);
  else
    glColor3f(0.5,0.5,0.5);

  graphicsengine->fontrenderer->glPrint(300,200,titledialog[2][global_variables->language].c_str(),0);

  if (state->intstate==1)
    glColor3f(1,1,1);
  else
    glColor3f(0.5,0.5,0.5);

  graphicsengine->fontrenderer->glPrint(300,180,titledialog[3][global_variables->language].c_str(),0);

  if (state->intstate==2)
    glColor3f(1,1,1);
  else
    glColor3f(0.5,0.5,0.5);

  graphicsengine->fontrenderer->glPrint(300,160,titledialog[4][global_variables->language].c_str(),0);

  glColor3f(0.5,0.5,0.5);

  graphicsengine->fontrenderer->glPrint(0,0,titledialog[5][global_variables->language].c_str(),0);

  glColor4f(1,1,1,1);

}
